unit FoProgi;
{*$DEFINE DEBUG}
{Define this when you want to check the lists for typos}
interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Grids, Menus, ActnList, ToolWin, ComCtrls, ImgList, ShellAPI, INIFiles,
  StdActns, AppEvnts, ExtCtrls, StdCtrls, TntGrids, TntForms;

type TAllTTDStrings=array [1..2449] of WideString;
type TBoolForAllTTDStrings=array [1..2449] of boolean;

type
  TFoForm = class(TTntForm)
    StringGrid1: TTntStringGrid;
    StatusBar1: TStatusBar;
    ToolBar1: TToolBar;
    MainMenu1: TMainMenu;
    ActionList1: TActionList;
    File1: TMenuItem;
    N1: TMenuItem;
    Exit1: TMenuItem;
    Save: TAction;
    ImageList1: TImageList;
    ToolButton1: TToolButton;
    Save1: TMenuItem;
    Run: TAction;
    ToolButton2: TToolButton;
    ToolButton3: TToolButton;
    Run1: TMenuItem;
    RunPatch: TAction;
    RunTTDPatch1: TMenuItem;
    ToolButton4: TToolButton;
    Configure: TAction;
    Configure1: TMenuItem;
    Find: TAction;
    ToolButton5: TToolButton;
    ToolButton6: TToolButton;
    Search1: TMenuItem;
    Find1: TMenuItem;
    EditCut1: TEditCut;
    EditCopy1: TEditCopy;
    EditPaste1: TEditPaste;
    ToolButton7: TToolButton;
    ToolButton8: TToolButton;
    ToolButton9: TToolButton;
    ToolButton10: TToolButton;
    Edit1: TMenuItem;
    Cut1: TMenuItem;
    Copy1: TMenuItem;
    Paste1: TMenuItem;
    CopyStrings: TAction;
    Other1: TMenuItem;
    Copystrings1: TMenuItem;
    JumpTo: TAction;
    ToolButton11: TToolButton;
    Jumpto1: TMenuItem;
    ChangeSpecial: TAction;
    Changespecial1: TMenuItem;
    ChangeKeybLay: TAction;
    Changekeyboardlayout1: TMenuItem;
    NextUntrans: TAction;
    ToolButton12: TToolButton;
    Nextuntranslated1: TMenuItem;
    Help1: TMenuItem;
    About1: TMenuItem;
    About: TAction;
    N2: TMenuItem;
    HelpContents1: THelpContents;
    Contents1: TMenuItem;
    HelpOverview: TAction;
    Overview1: TMenuItem;
    ToolButton13: TToolButton;
    ToolButton14: TToolButton;
    ApplicationEvents1: TApplicationEvents;
    PopupMenu1: TPopupMenu;
    Changecolor1: TMenuItem;
    Bluer1: TMenuItem;
    LightGray1: TMenuItem;
    Orange1: TMenuItem;
    Red1: TMenuItem;
    Purple1: TMenuItem;
    Gray1: TMenuItem;
    LightBrown1: TMenuItem;
    Green1: TMenuItem;
    Yellow1: TMenuItem;
    LightGreen1: TMenuItem;
    Pink1: TMenuItem;
    DarkBrown1: TMenuItem;
    White1: TMenuItem;
    LightBlue1: TMenuItem;
    LightGray2: TMenuItem;
    Mauve1: TMenuItem;
    Black1: TMenuItem;
    Showvariable1: TMenuItem;
    N4bytelongnumber1: TMenuItem;
    N2bytelongnumber1: TMenuItem;
    N1bytelongnumber1: TMenuItem;
    Yearnumber1: TMenuItem;
    Money1: TMenuItem;
    Text1: TMenuItem;
    Longdate1: TMenuItem;
    Shortdate1: TMenuItem;
    Speed1: TMenuItem;
    Drop2bytes1: TMenuItem;
    Liquidcargoamount1: TMenuItem;
    Insertlinebreak1: TMenuItem;
    Switchtosmallletters1: TMenuItem;
    Switchtobigletters1: TMenuItem;
    N3: TMenuItem;
    Reverttooriginal1: TMenuItem;
    N4: TMenuItem;
    Cut2: TMenuItem;
    Copy2: TMenuItem;
    Paste2: TMenuItem;
    Preview: TAction;
    Preview1: TMenuItem;
    PreviewTimer: TTimer;
    EditIngame: TAction;
    EditTTDPatchingametexts1: TMenuItem;
    AddnewID1: TMenuItem;
    N5: TMenuItem;
    DeletecurrenttextID1: TMenuItem;
    FontDialog1: TFontDialog;
    ChangeFont: TAction;
    Changeusedfont1: TMenuItem;
    OpenDialog1: TOpenDialog;
    SaveDialog1: TSaveDialog;
    ExportTexts: TAction;
    ImportTexts: TAction;
    N6: TMenuItem;
    ImportTexts1: TMenuItem;
    Exporttexts1: TMenuItem;
    ShowTextID: TAction;
    ShowtextIDs1: TMenuItem;
    ExportToGRF: TAction;
    ExporttoGRF1: TMenuItem;
    procedure FormResize(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Exit1Click(Sender: TObject);
    procedure SaveExecute(Sender: TObject);
    procedure SaveUpdate(Sender: TObject);
    procedure StringGrid1SetEditText(Sender: TObject; ACol, ARow: Integer;
      const Value: WideString);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure RunExecute(Sender: TObject);
    procedure RunPatchExecute(Sender: TObject);
    procedure RunPatchUpdate(Sender: TObject);
    procedure ConfigureExecute(Sender: TObject);
    procedure FindExecute(Sender: TObject);
    procedure CopyStringsExecute(Sender: TObject);
    procedure ApplicationEvents1Hint(Sender: TObject);
    procedure StringGrid1SelectCell(Sender: TObject; ACol, ARow: Integer;
      var CanSelect: Boolean);
    procedure JumpToExecute(Sender: TObject);
    procedure ChangeSpecialExecute(Sender: TObject);
    procedure ChangeKeybLayUpdate(Sender: TObject);
    procedure ChangeKeybLayExecute(Sender: TObject);
    procedure NextUntransExecute(Sender: TObject);
    procedure StringGrid1Exit(Sender: TObject);
    procedure StringGrid1KeyPress(Sender: TObject; var Key: Char);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure AboutExecute(Sender: TObject);
    procedure HelpOverviewExecute(Sender: TObject);
    procedure ApplicationEvents1Exception(Sender: TObject; E: Exception);
    procedure StringGrid1ContextPopup(Sender: TObject; MousePos: TPoint;
      var Handled: Boolean);
    procedure Black1Click(Sender: TObject);
    procedure Reverttooriginal1Click(Sender: TObject);
    procedure PreviewExecute(Sender: TObject);
    procedure PreviewTimerTimer(Sender: TObject);
    procedure EditIngameUpdate(Sender: TObject);
    procedure EditIngameExecute(Sender: TObject);
    procedure PopupMenu1Popup(Sender: TObject);
    procedure AddnewID1Click(Sender: TObject);
    procedure DeletecurrenttextID1Click(Sender: TObject);
    procedure ChangeFontExecute(Sender: TObject);
    procedure ExportTextsExecute(Sender: TObject);
    procedure ImportTextsExecute(Sender: TObject);
    procedure ShowTextIDExecute(Sender: TObject);
    procedure ExportToGRFExecute(Sender: TObject);
  private
    { Private declarations }
    OrigString:WideString;
    OldEditorMode:boolean;
    FontNotInstalled:boolean;
    procedure LoadStrings;
    procedure SaveStrings;
    procedure WMUser(var Msg:TMessage); message WM_USER;
    procedure RefreshStatusBar(row,col:integer);
  public
    { Public declarations }
    changed:boolean;
    function CheckConfig(const OrigExePath,TransExePath,PatchPath:string):boolean;
    function FindVersion(filesize:integer):integer;
    function CheckCError: boolean;
    function CompileCStyleString(const s1:WideString;var s2:WideString):boolean;
    function MakeCStyleString(const s:WideString):WideString;
    function MakeCodes(const s:string):string;
    function TTDTextToWideString(const TTDText:string):WideString;
    function WideStringToTTDText(const s:WideString; allowUtf8:boolean=true): string;
    function ImportFromFile(var input:TextFile; var texts:TAllTTDStrings;
                            var present:TBoolForAllTTDStrings; var errMsg:string):boolean;
  end;
  TStringListInfo=array[1..36] of record
                                   s,e,o:integer;
                                  end;
{Type for storing positions of string lists
 s - start - position of the first usable character in the string list
 e - end - position of the last usable character in the string list
 o - offset - see below}
  TPointerListInfo=array[1..41] of record
                                    s,e:integer;
                                   end;
{Type for storing positions of pointer lists
 s - start - position of the first pointer in the pointer list
 e - end - position of the 4th byte of the last pointer in the pointer list (the last modifiable byte)}
  PStringListInfo=^TStringListInfo;
  PPointerListInfo=^TPointerListInfo;

{TTD stores language-dependent texts in string lists. These string lists contain null-terminated
 strings. Pointer lists are usually situated after string lists. They contain 4-byte pointers. Every
 pointer points to the beginning of a string, but these pointers contain memory addresses. To get the
 position in the file from the memory address, you have to subtract an offset from it. This offset
 is always $407c00 in Windows versions, but it depends on the position of the string list in DOS
 versions. That's why these offsets are stored for every string list. A string can be situated in
 any string list as long as its pointer is set correctly. A pointer can point into the middle of an
 other string because of the metod of accessing strings, and this way only one string has to be
 saved instead of two or more. This space-saving opportunity is taken only for less than ten times
 in the original executable, but with "shortening" it can save much space.

 Legend of string lists:
 1..21: "Normal" string lists
 1.5: This string list was inserted because of TTDPatch. String list 1 was split into two.
      The first part ends before the "Version..." string in the About box, and string 1.5
      starts after this string. This is because TTDPatch needs this string to be there and be
      unchanged. TTD Translator will save the changed string to somewhere else, adjust its pointer,
      but TTDPatch will still read the original from the original place.
 2: This string list first seemed to be the part of list 1, but after the string "Graphics:",
    there is a strange part then the offset changes. The string "Graphics:" must remain on its
    position, so I had to start another list after it.
 11.5: After I entered all string lists for the American DOS version, I noticed that there is 5 bytes
       junk in the middle of the list 11, and the offset changes after this junk. This is why
       I had to split string 11 to two separate lists, excluding the junk.
 16.5: I had to split string list 16 because of the multihead patch of TTDPatch. Versions before
       1.9.1 alpha 5 used a fix offset to change a character here, but with TTD Translator, this
       character was moved to somewhere else, and TTDPatch spoiled another string. Excluding that
       position from string list 16 it didn't spoil anything, because no string used that position
       anymore.
 v1..v11: These string lists contain town name parts.
 CPU: This string lists contains the surnames of CPU players.

 Legend of pointer lists:
 1..21: "Normal" pointer lists
 2: There is a pointer pointing to the string "Graphics:" mentioned above, and it shouldn't be changed,
    so I had to end pointer list 1 before this pointer and start pointer list 2 after it.
 11.5: There is a pointer pointing to the junk in string list 11, and it shouldn't be changed, so
       I had to split pointer list 11 to two.
 months: Full names of months (January,February...) are originally stored in string list 1.5, but their
         pointers are in this pointer list.
 companies: Default company names are stored in string list 15 but their pointers are in this pointer
            list. Your company can be given a default name if you don't name it yourself, CPU companies
            can get default names, too.
 .. (Parent directory), Directory: These strings are stored in string list 15, but their addresses are
     in the code part. In fact both "lists" contain only one pointer, which is in the code part.
 Transport #1..3: There is a " Transport" string in string list 15, but three pointers point to it
     in the code part. These pointers are used when:
        -You set your name, but you don't set the name of your company. The company name will be
         Your_name+" Transport"
        -You neither set your name nor the name of your company, and you do something on the map.
         The compnay name will be Nearest_town+" Transport"
        -A newly launched CPU company starts building somewhere. Its name will be
         Nearest_town+" Transport"
     These three pointers can be set separately, so you can use different strings for the three
     different purposes above. These three "lists" are one pointer each, resulting in three entries
     in the main translator window
 vm1..vm11: Pointer lists for town name parts
 CPU: Pointers for surnames of CPU players}

{I've put the lists themselves in include files because you can edit them more easily in separate
 files than finding declarations in this file}

{$I american_dos.inc}
{$I american_win.inc}
{$I english_dos.inc}
{$I english_win.inc}
{$I french_dos.inc}
{$I french_win.inc}
{$I german_dos.inc}
{$I german_win.inc}
{$I spanish_dos.inc}
{$I spanish_win.inc}

const ExeTypes:array[1..10] of record
                                FileSize:integer;
                                PointerLists:PPointerListInfo;
                                StringLists:PStringListInfo;
                                CheckDateOffset:integer;
                               end=
       {Array for describing the supported executables. The program identifies the version from the
        FileSize member, then uses the remaining fields for working with it. CheckDateOffset is
        used for adjusting pointers in the code for showing dates. In the Hungarian TTD translation
        I had to change the date-showing code to change D/M/Y to Y/M/D used in Hungary. I wanted
        to continue using my program after this, so I've included support for the changed version
        in this program. CheckDateOffset is the position of the first changed byte in the date-
        showing code. The program reads bytes from this offset, decides wheter it is the original
        or the changed code, and updates the pointer stored in the code according to that.}
       {American DOS}
      ((FileSize:496543; PointerLists:@AmericanDosPointerLists; StringLists:@AmericanDosStringLists;
        CheckDateOffset:$3558c),
       {English DOS}
       (FileSize:496601; PointerLists:@EnglishDosPointerLists; StringLists:@EnglishDosStringLists;
        CheckDateOffset:$355c6),
       {French DOS}
       (FileSize:505759; PointerLists:@FrenchDosPointerLists; StringLists:@FrenchDosStringLists;
        CheckDateOffset:$3796c),
       {German DOS}
       (FileSize:499583; PointerLists:@GermanDosPointerLists; StringLists:@GermanDosStringLists;
        CheckDateOffset:$3614c),
       {Spanish DOS}
       (FileSize:506237; PointerLists:@SpanishDosPointerLists; StringLists:@SpanishDosStringLists;
        CheckDateOffset:$37b4a),
       {American Windows}
       (FileSize:1695744; PointerLists:@AmericanWinPointerLists; StringLists:@AmericanWinStringLists;
        CheckDateOffset:$13cd2f),
       {English Windows}
       (FileSize:1696256; PointerLists:@EnglishWinPointerLists; StringLists:@EnglishWinStringLists;
        CheckDateOffset:$13cf2f),
       {French Windows}
       (FileSize:1707008; PointerLists:@FrenchWinPointerLists; StringLists:@FrenchWinStringLists;
        CheckDateOffset:$13f92f),
       {German Windows}
       (FileSize:1699328; PointerLists:@GermanWinPointerLists; StringLists:@GermanWinStringLists;
        CheckDateOffset:$13db2f),
       {Spanish Windows}
       (FileSize:1707520; PointerLists:@SpanishWinPointerLists; StringLists:@SpanishWinStringLists;
        CheckDateOffset:$13fb2f));

const TextIDs:array[1..41] of integer=
($0000,$00c0,$0800,$6800,$2800,$3800,$4000,$1000,$1800,$2000,
$3000,$300d,$4800,$5000,$5800,$7000,$8800,$9000,$9800,$a000,$8000,$b000,
$e000,$e00c,$e044,$e045,$e046,$e047,$e048,
-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,$e019);

function GetFileSize(const name:string):integer;

const DOSVersions:set of 1..10=[1..5]; {This is needed because Change keyboard layout can only be used
                                        on DOS versions}
      ControlChars:array[$E07B..$E087] of WideChar=('N','n','b','w','m','s','u','D','d','v','e','S','l');    { \ Needed for     }
      ColorLetters:array[$E088..$E098] of WideChar=('0','1','2','3','4','5','6','7','8','9','a','b','c','d','e','f','g');{ / C-style strings}
      Colors:array[1..17] of TColor=($00f09440,$00d0ccd0,$0000c4ff,clRed,$00e88cb0,$0088b4b8,
       $0038b4ff,$0060e498,$0088fcff,$0080d0b8,$008898d8,$004864a8,clWhite,$00ffc888,$00686868,
       $00a88888,$00181418);
var
  FoForm: TFoForm;
  OrigExePath:string;
  TransExePath:string;
  PatchPath:string;
  OrigType,TransType:integer;

implementation

uses Conf, SaveF, jumpto, ChSpec, Keyb, NotFound, About, Find,
  previewf, ttdptxt, GRFExport, TntClasses, TntStdCtrls, TntControls, OsDep;

{$R *.DFM}

procedure TFoForm.FormResize(Sender: TObject);
var size:integer;
begin
{The width of columns 0 and 3 of the string grid should be constant, the remaining space is
used equally for the remaining two columns}
size:=StringGrid1.ClientWidth-5;
StringGrid1.ColWidths[0]:=60;
StringGrid1.ColWidths[3]:=60;
StringGrid1.ColWidths[1]:=(size-120) div 2;
StringGrid1.ColWidths[2]:=(size-120) div 2;
end;

procedure TFoForm.LoadStrings;
type intarr=array of integer;
     pintarr=^intarr;
var f:TMemoryStream;
    i:integer;
    IDs:intarr;

  function LoadStringsFromFile(in_file:TMemoryStream;out_list:TTntStrings;PointerLists:PPointerListInfo;
           StringLists:PStringListInfo;Ids:pintarr):boolean;
  {Loads all strings from an executable to a string list using the given version info.
   The result is true if all strings could be found}
  var i,j,k,num,ID:integer;
      s:string;
      ws:WideString;
      pointers:array of integer;
      ok:boolean;
      c:char;
  begin
   num:=1;
   Result:=true;
   for i:=low(PointerLists^) to high(PointerLists^) do
    begin
     {$IFDEF DEBUG}
     {Check if the length of the pointer list is multiply of 4 - if it isn't, there is a typo}
     if ((PointerLists^[i].e-PointerLists^[i].s+1) mod 4)<>0 then ShowMessage ('Error with pointers :'+IntToStr(i));
     {$ENDIF}
     {loading pointer list i}
     SetLength(pointers,(PointerLists^[i].e-PointerLists^[i].s+1) div 4);
     in_file.Position:=PointerLists^[i].s;
     in_file.ReadBuffer(pointers[0],PointerLists^[i].e-PointerLists^[i].s+1);
     if i<=High(TextIDs) then
      id:=TextIDs[i]
     else
      id:=-1;
     for j:=low(pointers) to high(pointers) do
      begin
       ok:=false;
       {We try to find which string list pointer j points to. If we decrease it by the offset of
        the right string list, it should point inside the string list}
       for k:=low(StringLists^) to high(StringLists^) do
        if (StringLists^[k].s+StringLists^[k].o<=pointers[j]) and
           (StringLists^[k].e+StringLists^[k].o>=pointers[j]) then
         begin
          {The following statement should be uncommented _only_ when you load original files.
           It checks if the first pointer in the pointer list points to the first string of
           a string list. This is only true in original executables, but if an original executable
           fails this check that means that there's a typo in the version info}
          (*if not (i in [23..29,38]) and (j=0) and (pointers[j]-StringLists^[k].o<>StringLists^[k].s) then
           ShowMessage(IntToStr(i));*)
          {We get here if pointer j points inside string list k. We can compute the position of the
           string.}
          in_file.Position:=pointers[j]-StringLists^[k].o;
          s:='';
          {We read it}
          repeat
           in_file.ReadBuffer(c,1);
           if c<>#0 then s:=s+c;
          until c=#0;
          ok:=true; {we set ok to true so we know at the end of the loop that we've found the string}
          Break;
         end;
       if not ok then {We didn't find the string}
        begin
         Result:=false;
         s:='-- Not found! --';
         NotFoundForm.ListBox1.Items.Add(IntToStr(num));
        end;
        ws:=TTDTextToWideString(s);
       ws:=MakeCStyleString(ws); {We must make C-style string from the loaded string if it's enabled}
       out_list[num]:=ws;
       if IDs<>nil then
        begin
         IDs^[num]:=id;
         if id<>-1 then inc(id);
        end;
       inc(num);
      end;
    end;
  end;

begin
 if not FileExists(TransExePath) then
  CopyFile(PChar(OrigExePath),PChar(TransExePath),false);
 f:=TMemoryStream.Create;
 f.LoadFromFile(OrigExePath);
 OrigType:=FindVersion(f.Size); {We identify the version by the file size}
 inc(ExeTypes[OrigType].StringLists^[1].e);
 {This increasing is needed because string list 1 ends before the string "Version..", but a pointer
  points to this string in the original version. We would get a "String not found" error then, but
  with increasing the end of string 1, the start of string "Version..." will be inside it, and we
  won't get an error. We decrease it after loading, so it won't be overwritten when saving}
 NotFoundForm.ListBox1.Clear;
 SetLength(IDs,StringGrid1.RowCount);
 if not LoadStringsFromFile(f,StringGrid1.Cols[1],ExeTypes[OrigType].PointerLists,ExeTypes[OrigType].StringLists,@IDs) then
  begin
   NotFoundForm.Label1.Caption:='Strings with the following numbers could not be found in the original executable:';
   NotFoundForm.ShowModal;
  end;
 dec(ExeTypes[OrigType].StringLists^[1].e);
 for i:=0 to high(IDs) do
  StringGrid1.Objects[0,i]:=TObject(IDs[i]);
 {We do the same with the translated executable}
 f.LoadFromFile(TransExePath);
 TransType:=FindVersion(f.Size);
 inc(ExeTypes[TransType].StringLists^[1].e);
 NotFoundForm.ListBox1.Clear;
 if not LoadStringsFromFile(f,StringGrid1.Cols[2],ExeTypes[TransType].PointerLists,ExeTypes[TransType].StringLists,nil) then
  begin
   NotFoundForm.Label1.Caption:='Strings with the following numbers could not be found in the translated executable:';
   NotFoundForm.ShowModal;
  end;
 f.free;
 dec(ExeTypes[TransType].StringLists^[1].e);
 {Erasing contents of the "Short." column}
 for i:=1 to 2449 do
  StringGrid1.Cells[3,i]:='';
 {Needed for Esc key to work}
 with StringGrid1 do
  OrigString:=Cells[Col,Row];
 changed:=false;
end;

procedure TFoForm.FormCreate(Sender: TObject);
{$IFDEF DEBUG}
var i,j,k:integer;

 function HasOverlap(s1,e1,s2,e2:cardinal):boolean;
  begin
   Result:=(s1>=s2) and (s1<=e2) or (e1>=s2) and (e1<=e2) or
           (s2>=s1) and (s2<=e1) or (e2>=s1) and (e2<=e1);
  end;
{$ELSE}
var i:integer;
{$ENDIF}
var b:TBitmap;
    ini:TIniFile;
//var f:textFile;
begin
Application.HelpFile:=ExtractFilePath(Application.ExeName)+'TTDTrans2.hlp';
{We fill static cells}
StringGrid1.Cells[0,0]:='Number';
StringGrid1.Cells[1,0]:='Original';
StringGrid1.Cells[2,0]:='Translated';
StringGrid1.Cells[3,0]:='Short.';
With StringGrid1 do
 for i:=1 to RowCount-1 do
  Cells[0,i]:=IntToStr(i);
{We restore previous size and position from the ini file}
ini:=TIniFile.Create(ExtractFilePath(Application.ExeName)+'ttdtrans2.ini');
i:=ini.ReadInteger('MainWindow','Left',-1);
if i<>-1 then
 begin
  Left:=i;
  Top:=ini.ReadInteger('MainWindow','Top',0);
  Width:=ini.ReadInteger('MainWindow','Width',320);
  Height:=ini.ReadInteger('MainWindow','Height',200);
  if (Left>Screen.Width-10) or (Top>Screen.Height-10) then
   begin
    Left:=0; Top:=0;
   end;
 end;
if ini.ReadBool('MainWindow','IsMaximized',false) then
 WindowState:=wsMaximized;
ini.free;
if Screen.Fonts.IndexOf('Transport Tycoon')=-1 then
 begin
  FontNotInstalled:=true;
  AddFontResource(PChar(ExtractFilePath(Application.ExeName)+'ttd.fon'));
  PostMessage(HWND_BROADCAST,WM_FONTCHANGE,0,0);
 end
else
 FontNotInstalled:=false;
{We can't start loading here because the form is not visible yet. It looks much better when
 error messages appear in front of the main window instead of appearing before it becomes visible.
 We send ourselves a message because the form will be visible when we get it.}
PostMessage(Handle,WM_USER,0,0);
OldEditorMode:=false;
{The following commented part is used to make the town name part of version informations.
 These strings are the same in all versions, so we can compute all data from only two,
 (the starting position of "vm1" and the offset of all town name string lists)
 then we write them to a file from where it can be pasted to the version info.}
(*AssignFile(f,'stlist.inc');
Rewrite(f);
for i:=25 to 35 do
 Writeln(f,'(s:$'+IntToHex(AmericanWinStringLists[i].s-AmericanWinPointerLists[30].s+$48a67,5)+
           '; e:$'+IntToHex(AmericanWinStringLists[i].e-AmericanWinPointerLists[30].s+$48a67,5)+
           '; o:$407c00), {v'+IntToStr(i-24)+'}');
CloseFile(f);
AssignFile(f,'plist.inc');
Rewrite(f);
for i:=30 to 40 do
 Writeln(f,'(s:$'+IntToHex(AmericanWinPointerLists[i].s-AmericanWinPointerLists[30].s+$48a67,5)+
           '; e:$'+IntToHex(AmericanWinPointerLists[i].e-AmericanWinPointerLists[30].s+$48a67,5)+
           '), {vm'+IntToStr(i-29)+'}');
CloseFile(f);*)
{$IFDEF DEBUG}
{In debug mode we check for all kind of overlaps in all version infos. Many typos can be find there
 before even loading an executable}
for i:=low(ExeTypes) to high(ExeTypes) do
 begin
  for j:=low(ExeTypes[i].PointerLists^) to high(ExeTypes[i].PointerLists^) do
   for k:=low(ExeTypes[i].StringLists^) to high(ExeTypes[i].StringLists^)  do
    if HasOverlap(ExeTypes[i].PointerLists^[j].s,ExeTypes[i].PointerLists^[j].e,
                  ExeTypes[i].StringLists^[k].s,ExeTypes[i].StringLists^[k].e) then
     ShowMessage('Overlap in ftype '+IntToStr(i)+' plist '+IntToStr(j)+' stlist '+IntToStr(k));
  for j:=low(ExeTypes[i].StringLists^) to high(ExeTypes[i].StringLists^) do
   for k:=low(ExeTypes[i].StringLists^) to j  do
    if (j<>k) and HasOverlap(ExeTypes[i].StringLists^[j].s,ExeTypes[i].StringLists^[j].e,
                  ExeTypes[i].StringLists^[k].s,ExeTypes[i].StringLists^[k].e) then
     ShowMessage('Overlap in ftype '+IntToStr(i)+' stlist '+IntToStr(j)+' stlist '+IntToStr(k));
  for j:=low(ExeTypes[i].PointerLists^) to high(ExeTypes[i].PointerLists^) do
   for k:=low(ExeTypes[i].PointerLists^) to j  do
    if (j<>k) and HasOverlap(ExeTypes[i].PointerLists^[j].s,ExeTypes[i].PointerLists^[j].e,
                  ExeTypes[i].PointerLists^[k].s,ExeTypes[i].PointerLists^[k].e) then
     ShowMessage('Overlap in ftype '+IntToStr(i)+' plist '+IntToStr(j)+' plist '+IntToStr(k));
 end;
{$ENDIF}
 b:=TBitmap.Create;
 b.Height:=16;
 b.Width:=16;
 for i:=0 to Changecolor1.Count-1 do
  with b.canvas do
   begin
    Brush.Color:=Colors[Changecolor1.Items[i].Tag-$e087];
    FillRect(Rect(0,0,16,16));
    Changecolor1.Items[i].Bitmap:=b;
   end;
 b.Free;
end;

procedure TFoForm.Exit1Click(Sender: TObject);
begin
Close;
end;

procedure TFoForm.SaveStrings;
begin
{We do the actual saving in the code of a modal dialog box, so we can show the progress in a separate
 window. That's not a too elegant solution, but I didn't want to use threads}
if CheckCError then
FormSave.ShowModal;
end;

procedure TFoForm.SaveExecute(Sender: TObject);
begin
SaveStrings;
end;

procedure TFoForm.SaveUpdate(Sender: TObject);
begin
Save.Enabled:=changed; {We should only save when there are changes}
end;

procedure TFoForm.StringGrid1SetEditText(Sender: TObject; ACol,
  ARow: Integer; const Value: WideString);
begin
{A cell of the string grid is edited}
If ACol=2 then changed:=true; {If it's the translated column, there are unsaved changes}
end;

procedure TFoForm.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
{To prevent losing unsaved changes when closing program}
begin
 if changed then
  case Application.MessageBox('The texts were modified since you last saved them'#10#13'Do you want to save them now?',
                  'Unsaved changes',MB_ICONQUESTION or MB_YESNOCANCEL) of
   ID_YES: begin
            SaveStrings;
            CanClose:=not changed;
           end;
   ID_CANCEL: CanClose:=false;
  end;
end;

procedure TFoForm.RunExecute(Sender: TObject);
begin
if changed then SaveStrings; {We have to save changes before we can test them}
if not changed then {If saving failed, changed remains True}
 ShellExecute(handle,'open',PChar(TransExePath),'',PChar(ExtractFilePath(TransExePath)),SW_SHOW);
end;

procedure TFoForm.RunPatchExecute(Sender: TObject);
{Like RunExecute, but we enable forcerebuildowl when running TTDPatch}
begin
if changed then SaveStrings;
if not changed then
 ShellExecute(handle,'open',PChar(PatchPath),'-Xr',PChar(ExtractFilePath(PatchPath)),SW_SHOW);
end;

function TFoForm.CheckConfig(const OrigExePath,TransExePath,PatchPath:string): boolean;
{Checks if the given paths are correct and copies the original executable to the translated
 one if it doesn't exist. If there's an error, the procedure shows it then returns false.
 If it returns true that means that everything is OK and all files are availbale.}
begin
Result:=false;
if not FileExists(OrigExePath) then
 Application.MessageBox('The file you specified for the original executable doesn''t exist.'#10#13'Please enter a valid filename.',
            'Invalid path',MB_ICONERROR or MB_OK)
else if (PatchPath<>'') and not FileExists(PatchPath) then
 Application.MessageBox('The file you specified for the TTDPatch executable doesn''t exist.'#10#13'Please enter a valid filename or leave it blank if you don''t want to use TTDPatch.',
            'Invalid path',MB_ICONERROR or MB_OK)
else if FindVersion(GetFileSize(OrigExePath))=-1 then
 Application.MessageBox('The file you specified for the original executable has an unknown size.'#10#13'If you are sure that it''s a TTD executable, please send it to the author.','Unknown filesize',MB_ICONERROR or MB_OK)
else if not FileExists(TransExePath) and not CopyFile(PChar(OrigExePath),PChar(TransExePath),true) then
 Application.MessageBox('The file you specified for the translated executable doesn''t exist'#10#13'and an error occured while copying the original file.'#10#13'Please enter another path or try to copy the file yourself.',
            'Error copying file',MB_ICONERROR or MB_OK)
else if (FileGetAttr(TransExePath) and faReadOnly) <> 0 then
 Application.MessageBox('The file you specified for the translated executable is read-only.'#10#13'Please remove the read-only flag from it or enter another filename.','Read-only translated file',MB_ICONERROR or MB_OK)
else if FindVersion(GetFileSize(TransExePath))=-1 then
 Application.MessageBox('The file you specified for the translated executable has an unknown size.'#10#13'If you are sure that it''s a TTD executable, please send it to the author.','Unknown filesize',MB_ICONERROR or MB_OK)
else Result:=true;
end;

procedure TFoForm.RunPatchUpdate(Sender: TObject);
begin
 RunPatch.Enabled:= PatchPath<>'';
end;

procedure TFoForm.ConfigureExecute(Sender: TObject);
begin
 if not CheckCError then Exit; {We don't do anything if the currently edited C-style text has errors}
 if changed then
  case Application.MessageBox('The texts were modified since you last saved them'#10#13'Do you want to save them before you enter another paths?',
                  'Unsaved changes',MB_ICONQUESTION or MB_YESNOCANCEL) of
   ID_YES: begin
            SaveStrings;
            if not changed then Exit;
           end;
   ID_CANCEL: Exit;
  end;
 if ConfigForm.ShowModal=mrOK then {If the Configuration dialog box was closed with the OK button,
                                    we load all strings}
  LoadStrings;
end;

procedure TFoForm.WMUser(var Msg: TMessage);
{Performs initialization, error checking and loading after starting the program}
var i:TIniFile;
    j:integer;
    f:TFont;
begin
{We load settings from the ini file}
i:=TIniFile.Create(ExtractFilePath(Application.ExeName)+'ttdtrans2.ini');
OrigExePath:=i.ReadString('Paths','OrigExePath','');
TransExePath:=i.ReadString('Paths','TransExePath','');
PatchPath:=i.ReadString('Paths','PatchPath','');
f:=TFont.Create;
F.Name:=i.ReadString('Options','FontName','MS Shell Dlg');
F.Charset:=i.ReadInteger('Options','FontCharset',DEFAULT_CHARSET);
F.Size:=i.ReadInteger('Options','FontSize',8);
F.Style:=TFontStyles(byte(i.ReadInteger('Options','FontStyle',0)));
for j:=0 to Screen.FormCount-1 do
 with Screen.Forms[j] do
  begin
   ScaleBy(f.Size,font.Size);
   Font:=f;
  end;
with PreviewForm do
 begin
  RichEdit1.Color:=i.ReadInteger('Preview','BackColor',clBtnFace);
  RichEdit1.Font.Color:=i.ReadInteger('Preview','TextColor',clWindowText);
  Double.Checked:=i.ReadBool('Preview','DoubleSize',true);
  Width:=i.ReadInteger('Preview','Width',300);
  Height:=i.ReadInteger('Preview','Height',150);
  j:=i.ReadInteger('Preview','Left',-1);
  if j<>-1 then
   begin
    Left:=j;
    Top:=i.ReadInteger('Preview','Top',0);
    if (Left>Screen.Width-10) or (Top>Screen.Height-10) then
     begin
      Left:=0; Top:=0;
     end;
   end;
  if i.ReadBool('Preview','Visible',false) then
   Preview.Execute;
  PreviewForm.UseTTDFont.Checked:=not i.ReadBool('Preview','UseTTDFont',true);
  PreviewForm.UseTTDFontClick(Self);
 end;
with InGameText do
 begin
  Width:=i.ReadInteger('IngameWin','Width',600);
  Height:=i.ReadInteger('IngameWin','Height',400);
  j:=i.ReadInteger('IngameWin','Left',-1);
  if j<>-1 then
   begin
    Position:=poDesigned;
    Left:=j;
    Top:=i.ReadInteger('IngameWin','Top',0);
    if (Left>Screen.Width-10) or (Top>Screen.Height-10) then
     begin
      Left:=0; Top:=0;
     end;
   end;
  if i.ReadBool('IngameWin','IsMaximized',false) then
   WindowState:=wsMaximized; 
 end;
{If OrigExePath or TransExePath is not specified then we need to configure the program}
if (OrigExePath='') or (TransExePath='') then
 begin
  Application.MessageBox('You are running this program for the first time'#10#13'Please enter the locations of the necessary files',
             'First run',MB_ICONINFORMATION or MB_OK);
  if ConfigForm.ShowModal<>mrOK then {If the Configuration dialog box was closed by pressin Cancel,
                                      we can't continue the program}
   begin
    Close;
    Exit;
   end;
 end
else if not CheckConfig(OrigExePath,TransExePath,PatchPath) then
{There was another error. CheckConfig has already shown the error message, we only need to show
 the Configuration dialog box}
 if ConfigForm.ShowModal<>mrOK then
   begin
    Close;
    Exit;
   end;
{Nothing went wrong or everything was corrected - we can load strings}
LoadStrings;
end;

procedure TFoForm.FindExecute(Sender: TObject);
begin
 if CheckCError then {We can't move from the current cell if it has errors}
  FindForm.Show;
end;

procedure TFoForm.CopyStringsExecute(Sender: TObject);
var i:cardinal;
begin
if not CheckCError then Exit; {We don't copy anything if there's error in the current cell}
if Application.MessageBox('This will copy all strings on the left side to the right.'#10#13'All strings on the right will be lost.'#10#13'Are you sure you want to do that?',
   'Confirmation',MB_ICONQUESTION or MB_YESNO)=ID_YES then
 begin
  for i:=1 to StringGrid1.RowCount-1 do
   StringGrid1.Cells[2,i]:=StringGrid1.Cells[1,i];
  changed:=true;
 end;
end;

procedure TFoForm.ApplicationEvents1Hint(Sender: TObject);
begin
if (Application.Hint='') then
{We show character codes in the status bar if C-style strings are disabled and there's no hint}
 with StringGrid1 do
  RefreshStatusBar(Row,Col)
else
 StatusBar1.SimpleText:=Application.Hint;
end;

function TFoForm.MakeCodes(const s: string): string;
{Makes a text containing the character codes of s}
var i:cardinal;
begin
 Result:='';
 for i:=1 to length(s) do
  Result:=Result+IntToStr(ord(s[i]))+' ';
end;

procedure TFoForm.StringGrid1SelectCell(Sender: TObject; ACol,
  ARow: Integer; var CanSelect: Boolean);
{The user's trying to select another cell}
var s:WideString;
begin
 if not CheckCError then {If there's an error in the current cell, we don't allow to leave it}
  begin
   CanSelect:=false;
   Exit;
  end
 else if StringGrid1.col in [1..2] then
 {We have a correct C-style string, but it may contain special characters, so we re-make it}
  with StringGrid1 do
   begin
    CompileCStyleString(Cells[Col,Row],s);
    Cells[Col,Row]:=MakeCStyleString(s);
   end;
 if ACol=3 then CanSelect:=false {We can't select column 3 - it has no use}
 else
  OrigString:=StringGrid1.Cells[ACol,ARow]; {We store the contents of the new cell so we can
                                             restore it when the user presses Esc}
 if CanSelect then
  begin
   FoForm.Hint:=''; {FoForm.hint contains the number of remaining bytes after saving - we need to
                     clear it, else it would be shown in the status bar instead of the codes}
   RefreshStatusBar(ARow,ACol);
  end;
end;

procedure TFoForm.JumpToExecute(Sender: TObject);
var i:cardinal;
begin
 if not CheckCError then Exit; {We don't jump anywhere if there's error in the current cell}
 if JumpToForm.ShowModal=mrOK then {If the user pressed ok in the Jump to dialog box, we convert
                                    the number then jump there}
  begin
   i:=StrToInt(JumpToForm.JumpToNum.Text);
   StringGrid1.Row:=i;
   StringGrid1.Col:=1;
  end;
end;

function TFoForm.FindVersion(filesize: integer): integer;
{Find version from filesize. If filesize is unknown, it returns -1}
var i:integer;
begin
 Result:=-1;
 for i:= Low(ExeTypes) to High(ExeTypes) do
  if ExeTypes[i].FileSize=filesize then
   Result:=i;
end;

function GetFileSize(const name:string):integer;
{There's no built-in function to get the filesize from filename so I had to write one}
var f:file;
begin
 FileMode:=0; {We don't want to make error when opening read-only files}
 AssignFile(f,name);
 Reset(f,1);
 Result:=FileSize(f);
 Close(f);
 FileMode:=2;
end;

procedure TFoForm.ChangeSpecialExecute(Sender: TObject);
begin
 if CheckCError then ChangeSpec.ShowModal; {We don't allow the user to onen this dialog box until
                                            the current cell is corrected}
end;

procedure TFoForm.ChangeKeybLayUpdate(Sender: TObject);
begin
 ChangeKeybLay.Enabled:= TransType in DOSVersions; {This action can be used only with DOS versions}
end;

procedure TFoForm.ChangeKeybLayExecute(Sender: TObject);
begin
 if CheckCError then KeybLay.ShowModal;{We don't allow the user to onen this dialog box until
                                        the current cell is corrected}
end;

procedure TFoForm.NextUntransExecute(Sender: TObject);
var i:integer;
begin
 if not CheckCError then Exit; {The user can't leave a cell containing errors}
 with StringGrid1 do
  for i:=Row+1 to RowCount-1 do
   if (Cells[1,i]<>'') and (Cells[1,i]=Cells[2,i]) then
    begin
     Row:=i; Col:=2;
     Exit;
    end;
 {If there was an untranslated text, we've already exited so we show the error dialog}
 Application.MessageBox('No more untranslated texts','Information',MB_ICONINFORMATION or MB_OK);
end;

function TFoForm.MakeCStyleString(const s: WideString): WideString;
{Makes C-style string from a normal string}
var i:cardinal;
begin
 Result:='';
 for i:=1 to length(s) do
  case s[i] of
   #0: Result:=Result+'\0';
   #13: Result:=Result+'\n';
   #14: Result:=Result+'\s';
   #15: Result:=Result+'\l';
   #$E088..#$E098: Result:=Result+'\c'+ColorLetters[ord(s[i])];
   '\': Result:=Result+'\\';
   #$E07B..#$E087: Result:=Result+'%'+ControlChars[ord(s[i])];
   '%': Result:=Result+'%%';
   #1..#12,#16..#31,#153..#158:Result:=Result+'\x'+IntToHex(ord(s[i]),2);
   #$E000..#$E07A,#$E099..#$E0FF: Result:=Result+'\o'+IntToHex(ord(s[i]) and $FF,2);
   else Result:=Result+s[i];
  end;
end;

function TFoForm.CompileCStyleString(const s1: WideString; var s2: WideString): boolean;
{Tries to make a normal string from the C-style string s1.
 If it's succesful, the result is true and s2 contains the normal string.
 If it isn't the result is false and s2 contains an error message}
var i,j:cardinal;
    ok:boolean;
begin
 Result:=false;
 s2:='';
 i:=1;
 {I contains the current position in s1}
 while i<=length(s1) do
  begin
   case s1[i] of
    '%': if i<length(s1) then {if there's a percent sign, we check if there's a character after it}
          begin
           inc(i);
           ok:=false;
           {ok becomes true if it was a correct sequence}
           if s1[i]='%' then {%% -> %}
            begin
             s2:=s2+'%';
             ok:=true;
            end
           else if s1[i]='U' then
            begin
             s2:=s2+#134;
             ok:=true;
            end
           else
            for j:=low(ControlChars) to high(ControlChars) do {We try to find it in ControlChars}
             if ControlChars[j]=s1[i] then
              begin
               {We found it, the index is the code of the character}
               s2:=s2+WideChar(j);
               ok:=true;
               Break;
              end;
           if not ok then {ok is false - the sequence was incorrect}
            begin
             s2:='Incorrect % sequence at position '+IntToStr(i-1);
             Exit;
            end;
          end
         else {no character after the percent sign}
          begin
           s2:='Unmatched % sign at the end of the text';
           Exit;
          end;
    '\': if i<length(s1) then {check if there's a character after the backslash}
          begin
           inc(i);
           case s1[i] of
            '0':s2:=s2+#0;
            '\':s2:=s2+'\'; {\\ -> \}
            'n':s2:=s2+#13; {\n -> #13 (new line)}
            's':s2:=s2+#14; {\s -> #14 (small letters)}
            'l':s2:=s2+#15; {\l -> #15 (large letters)}
            'x': begin
                  if Length(s1)<i+2 then {\x needs two more characters after it}
                   begin
                    s2:='\x sequence without character number at the end of the text';
                    Exit;
                   end;
                  try
                   s2:=s2+WideChar(StrToInt('$'+Copy(s1,i+1,2))); {We try to convert it}
                  except
                   {It was invalid}
                   s2:='\x sequence with invalid character number at position '+IntToStr(i);
                   Exit;
                  end;
                  inc(i,2);
                 end;
            'o': begin
                  if Length(s1)<i+2 then {\o needs two more characters after it}
                   begin
                    s2:='\o sequence without character number at the end of the text';
                    Exit;
                   end;
                  try
                   s2:=s2+WideChar(StrToInt('$'+Copy(s1,i+1,2))+$E000); {We try to convert it}
                  except
                   {It was invalid}
                   s2:='\o sequence with invalid character number at position '+IntToStr(i);
                   Exit;
                  end;
                  inc(i,2);
                 end;
            'c': begin
                  if i=length(s1) then {\c needs a coloring character}
                   begin
                    s2:='\c sequence without color specifier at the end of the text';
                    Exit;
                   end;
                  ok:=false;
                  {ok becomes true when we find the coloring character in ColorLetters}
                  inc(i);
                  for j:=low(ColorLetters) to high(ColorLetters) do
                   if ColorLetters[j]=s1[i] then
                    begin
                     {The index is the code of the character}
                     s2:=s2+WideChar(j);
                     ok:=true;
                    end;
                  if not ok then {This character isn't in ColorLetters}
                   begin
                    s2:='Invalid color specifier for \c at position '+IntToStr(i-2);
                    Exit;
                   end;
                 end;
            else begin {Another character after the backslash - it is invalid}
                  s2:='Incorrect \ sequence at position '+IntToStr(i-1);
                  Exit;
                 end;
           end;
          end
         else {no character after the backslash}
          begin
           s2:='Unmatched \ sign at the end of the text';
           Exit;
          end;
    #$0A: ; {Swallow LF of CR/LF pairs}
    else s2:=s2+s1[i]; {isn't backslash, isn't percent sign -> just copy it}
   end;
   inc(i);
  end;
 Result:=true; {We haven't exited because of any error, so everything is OK}
end;

procedure TFoForm.StringGrid1Exit(Sender: TObject);
begin
 if not CheckCError then StringGrid1.SetFocus; {If there's error in the current cell, the string grid
                                                prevents losing focus}
end;

procedure TFoForm.StringGrid1KeyPress(Sender: TObject; var Key: Char);
begin
 with StringGrid1 do
  if (Key=#13) and EditorMode and not CheckCError then
  {The user wants to exit editor mode by pressing Enter, but there's an error in the text,
   so we can't allow pressing Enter}
   Key:=#0
  else if (Key=#13) and not EditorMode then
  {The user enters editor mode, but we save the original text first, so we can restore it
   when the user presses Esc}
   OrigString:=Cells[Col,Row]
  else if Key=#27 then
   begin
    {The user presses Esc - we restore the original text}
    Cells[Col,Row]:=OrigString;
    EditorMode:=false;
   end;
end;

function TFoForm.CheckCError: boolean;
{Check if the current cell in the string grid is correct. If it isn't, we show an error message
and return false.}
var s:WideString;
begin
 with StringGrid1 do
  if (col in [1..2]) and not CompileCStyleString(Cells[Col,Row],s) then
   begin
    result:=false;
    Application.MessageBox(PChar('The C-style string you entered has an error:'#10#13+string(s)+#10#13'You must fix this error to continue or press ESC to undo your changes'),'Error in string',MB_ICONERROR);
   end
  else
   result:=true;
end;

procedure TFoForm.FormClose(Sender: TObject; var Action: TCloseAction);
{The program is being closed - we save the setting of C-style strings here. Other settings are
saved when the user presses OK in the Configuration dialog box}
var i:TIniFile;
    place:WINDOWPLACEMENT;
begin
i:=TIniFile.Create(ExtractFilePath(Application.ExeName)+'ttdtrans2.ini');
i.WriteString('Options','FontName',Font.Name);
i.WriteInteger('Options','FontCharset',Font.Charset);
i.WriteInteger('Options','FontSize',Font.Size);
i.WriteInteger('Options','FontStyle',byte(Font.Style));
place.length:=sizeof(place);
GetWindowPlacement(Handle,@place);
i.WriteBool('MainWindow','IsMaximized',WindowState = wsMaximized);
with place.rcNormalPosition do
 begin
  i.WriteInteger('MainWindow','Left',Left);
  i.WriteInteger('MainWindow','Top',Top);
  i.WriteInteger('MainWindow','Width',Right-Left);
  i.WriteInteger('MainWindow','Height',Bottom-Top);
 end;
with PreviewForm do
 begin
  i.WriteInteger('Preview','BackColor',RichEdit1.Color);
  i.WriteInteger('Preview','TextColor',RichEdit1.Font.Color);
  i.WriteBool('Preview','DoubleSize',Double.Checked);
  i.WriteInteger('Preview','Left',Left);
  i.WriteInteger('Preview','Top',Top);
  i.WriteInteger('Preview','Width',Width);
  i.WriteInteger('Preview','Height',Height);
  i.WriteBool('Preview','Visible',Visible);
  i.WriteBool('Preview','UseTTDFont',UseTTDFont.Checked);
 end;
GetWindowPlacement(InGameText.Handle,@place);
i.WriteBool('IngameWin','IsMaximized',InGameText.WindowState = wsMaximized);
with place.rcNormalPosition do
 begin
  i.WriteInteger('IngameWin','Left',Left);
  i.WriteInteger('IngameWin','Top',Top);
  i.WriteInteger('IngameWin','Width',Right-Left);
  i.WriteInteger('IngameWin','Height',Bottom-Top);
 end;
i.free;
if FontNotInstalled then
 begin
  RemoveFontResource(PChar(ExtractFilePath(Application.ExeName)+'ttd.fon'));
  PostMessage(HWND_BROADCAST,WM_FONTCHANGE,0,0);
 end;
end;

procedure TFoForm.AboutExecute(Sender: TObject);
begin
AboutForm.ShowModal;
end;

procedure TFoForm.HelpOverviewExecute(Sender: TObject);
begin
 Application.HelpCommand(HELP_CONTEXT,1);
end;

procedure TFoForm.ApplicationEvents1Exception(Sender: TObject;
  E: Exception);
begin
 Application.ShowException(E);
end;

procedure TFoForm.StringGrid1ContextPopup(Sender: TObject;
  MousePos: TPoint; var Handled: Boolean);
begin
 if not StringGrid1.EditorMode then Handled:=true;
end;

procedure TFoForm.Black1Click(Sender: TObject);
var ToAdd,s:WideString;
    Clicked:TMenuItem;
    oldsl,oldss:integer;
    StringGrid1:TTntStringGrid;
begin
 StringGrid1:=PopupMenu1.PopupComponent as TTntStringGrid;
 Clicked:=Sender as TMenuItem;
 ToAdd:=WideChar(Clicked.Tag);
 ToAdd:=MakeCStyleString(ToAdd);
 if StringGrid1.EditorMode and (StringGrid1.ControlCount>0) and
    (StringGrid1.Controls[0] is TCustomEdit) then
  with TCustomEdit(StringGrid1.Controls[0]) do
   begin
    oldss:=SelStart;
    oldsl:=SelLength;
    s:=TntControl_GetText(StringGrid1.Controls[0]);
    Insert(ToAdd,s,oldss+1);
    with StringGrid1 do
     begin
      EditorMode:=false;
      Cells[Col,Row]:=s;
      EditorMode:=true;
     end;
    TntControl_SetText(StringGrid1.Controls[0],s);
    SelStart:=oldss+Length(ToAdd);
    SelLength:=oldsl;
   end;
 changed:=true;
end;

procedure TFoForm.Reverttooriginal1Click(Sender: TObject);
begin
 if (PopupMenu1.PopupComponent=StringGrid1) then
  with StringGrid1 do
   Cells[Col,Row]:=OrigString
 else if (PopupMenu1.PopupComponent=InGameText.StringGrid1) then
  with InGameText.StringGrid1 do
   Cells[Col,Row]:=InGameText.OrigString
 else if (PopupMenu1.PopupComponent=EditOSDep.StringGrid1) then
  with EditOSDep.StringGrid1 do
   Cells[Col,Row]:=EditOSDep.OrigString;
 (PopupMenu1.PopupComponent as TTntStringGrid).EditorMode:=false;  
end;

procedure TFoForm.PreviewExecute(Sender: TObject);
begin
 Preview.Checked:= not Preview.Checked;
 PreViewForm.Visible:=Preview.Checked;
 PreviewTimer.Enabled:=Preview.Checked;
end;

procedure TFoForm.PreviewTimerTimer(Sender: TObject);
begin
 With StringGrid1 do
  PreviewForm.PreviewText:=Cells[Col,Row];
end;

procedure TFoForm.EditIngameUpdate(Sender: TObject);
begin
 RunPatch.Enabled:= PatchPath<>'';
end;

procedure TFoForm.EditIngameExecute(Sender: TObject);
begin
 PreviewTimer.Enabled:=false;
 InGameText.DestList:=nil;
 IngameText.ShowModal;
 PreviewTimer.Enabled:=Preview.Checked;
end;

procedure TFoForm.PopupMenu1Popup(Sender: TObject);
begin
 With PopupMenu1 do
  begin
   if PopupComponent=nil then PopupComponent:=Screen.ActiveForm.FindChildControl('StringGrid1');
   AddnewID1.Visible:= PopupComponent=InGameText.StringGrid1;
   DeletecurrenttextID1.Visible:= PopupComponent=InGameText.StringGrid1;
   N5.Visible:= PopupComponent=InGameText.StringGrid1;
   AddnewID1.Enabled:= PopupComponent=InGameText.StringGrid1;
   DeletecurrenttextID1.Enabled:= PopupComponent=InGameText.StringGrid1;
   With PopupComponent as TStringGrid do
    begin
     Changecolor1.Enabled:=EditorMode;
     Showvariable1.Enabled:=EditorMode;
     Insertlinebreak1.Enabled:=EditorMode;
     Switchtosmallletters1.Enabled:=EditorMode;
     Switchtobigletters1.Enabled:=EditorMode;
     Reverttooriginal1.Enabled:=EditorMode;
    end;
  end;
end;

procedure TFoForm.AddnewID1Click(Sender: TObject);
var idName:string;
    i,j:integer;
begin
 if not InGameText.CheckCError then Exit;
 idName:=InputBox('Add new ID','Name of the new identifier:','');
 if idName='' then Exit;
 with InGameText.StringGrid1 do
  begin
   for i:=1 to RowCount-1 do
    if UpperCase(Cells[1,i])=UpperCase(idName) then
     begin
      Application.MessageBox('Identifier already exists','Error',MB_ICONERROR);
      Exit;
     end;
   i:=Row+1;
   while (i<RowCount) and (Cells[0,i]='') do inc(i);
   RowCount:=RowCount+1;
   for j:=RowCount-2 downto i do
    begin
     Cells[0,j+1]:=Cells[0,j];
     Cells[1,j+1]:=Cells[1,j];
     Cells[2,j+1]:=Cells[2,j];
     Cells[3,j+1]:=Cells[3,j];
    end;
   Cells[0,i]:='???';
   Cells[1,i]:=idName;
   Cells[2,i]:='???';
   Cells[3,i]:='';
   Row:=i;
  end;
end;

procedure TFoForm.DeletecurrenttextID1Click(Sender: TObject);
var i:integer;
begin
 if not InGameText.CheckCError then Exit;
 with InGameText.StringGrid1 do
  begin
   if RowCount=2 then
    begin
     Application.MessageBox('Cannot delete last entry from the file','Error',MB_ICONERROR);
     Exit;
    end;
   for i:=Row to RowCount-2 do
    begin
     Cells[0,i]:=Cells[0,i+1];
     Cells[1,i]:=Cells[1,i+1];
     Cells[2,i]:=Cells[2,i+1];
     Cells[3,i]:=Cells[3,i+1];
    end;
   RowCount:=RowCount-1;
  end;
end;


procedure TFoForm.ChangeFontExecute(Sender: TObject);
var i:integer;
begin
 FontDialog1.Font:=FoForm.Font;
 if FontDialog1.Execute then
  for i:=0 to Screen.FormCount-1 do
   with Screen.Forms[i] do
    begin
     ScaleBy(FontDialog1.Font.Size,Font.Size);
     Font:=FontDialog1.Font;
    end;
end;

procedure TFoForm.ExportTextsExecute(Sender: TObject);
var f:TextFile;
    i,j,k:integer;
    s,s2:WideString;
begin
 If not CheckCError then Exit;
 If not SaveDialog1.Execute then Exit;
 AssignFile(f,SaveDialog1.FileName);
 Rewrite(f);
 for i:=1 to StringGrid1.RowCount-1 do
  begin
   s:='{'+IntToStr(i)+'}';
   k:=length(s);
   write(f,s);
   s:=StringGrid1.Cells[2,i];
   if not CompileCStyleString(s,s2) then
    begin
     ShowMessage('Error in string number '+IntToStr(i)+': '+s+' '+s2);
     CloseFile(f);
     Exit;
    end;
   s2:=MakeCStyleString(s2);
   for j:=1 to length(s2) do
    begin
     write(f,UTF8Encode(s2[j]));
     inc(k);
     if (k>80) or ((k>70) and (s2[j]=' ')) or ((j>1) and (s2[j-1]='\') and (s2[j]='n')) then
      begin
       writeln(f);
       k:=0;
      end;
    end;
   if k>0 then writeln(f);
  end;
 CloseFile(f);
 Application.MessageBox('Exporting successful','Success',MB_ICONINFORMATION);
end;

function TFoForm.ImportFromFile(var input: TextFile;
  var texts: TAllTTDStrings; var present: TBoolForAllTTDStrings;
  var errMsg: string): boolean;
var acttextno:integer;
    lineno:integer;
    line:string;
    wline:WideString;
    i:integer;
    s2:WideString;

 procedure Error(const s:WideString);
  begin
   errMsg:='Error in text file at line '+IntToStr(lineno)+#13#10+s;
  end;

begin
 Result:=false;
 FillChar(present,sizeof(present),0);
 //for i:=low(present) to high(present) do
 // present[i]:=false;
 acttextno:=0;
 lineno:=0;
 while not Eof(input) do
  begin
   inc(lineno);
   readln(input,line);
   wline:=UTF8Decode(line);
   if (lineno=1) and (wline[1]=#$FEFF) then
    Delete(wline,1,1);
   if TrimLeft(wline)[1]='{' then
    begin
     wline:=TrimLeft(wline);
     i:=Pos('}',wline);
     if i=0 then
      begin Error('Opening "{" bracket isn''t closed'); Exit; end;
     if acttextno>=1 then
      begin
       if not CompileCStyleString(texts[acttextno],s2) then
        begin dec(lineno); Error('C-style error in text: '+s2); Exit; end;
       texts[acttextno]:=s2;
      end;
     s2:=Copy(wline,1,i-1);
     Delete(wline,1,i);
     Delete(s2,1,1);
     s2:=trim(s2);
     try
      acttextno:=StrToInt(s2);
     except
      on EConvertError do
       begin Error('Incorrect number in brackets'); Exit; end;
     end;
     if not present[acttextno] then
      begin
       present[acttextno]:=true;
       texts[acttextno]:='';
      end
     else
      begin Error('Duplicate text number'); Exit; end;
    end;
   if acttextno=0 then
    begin Error('Text before first text number'); Exit; end;
   texts[acttextno]:=texts[acttextno]+wline;
  end;
 Result:=true;
end;

procedure TFoForm.ImportTextsExecute(Sender: TObject);
var f:TextFile;
    b:boolean;
    i:integer;
    texts:TAllTTDStrings;
    occurs:TBoolForAllTTDStrings;
    err:string;

begin
 If not CheckCError then Exit;
 If not OpenDialog1.Execute then Exit;
 AssignFile(f,OpenDialog1.FileName);
 Reset(f);
 if not ImportFromFile(f,texts,occurs,err) then
  begin
   CloseFile(f);
   Application.MessageBox(PChar(err),'Error in input',MB_ICONERROR or MB_OK);
   Exit;
  end;
 CloseFile(f);
 b:=true;
 for i:=low(occurs) to high(occurs) do
  b:=b and occurs[i];
 if not b then
  if Application.MessageBox('Not all texts are defined in the include file.'#10#13'This means some of the translated strings will retain their current contents after including.'#10#13'Do you want to continue?',
     'Undefined texts',MB_ICONQUESTION or MB_YESNO)=ID_NO then
   begin
    Exit;
   end;
 for i:=1 to StringGrid1.RowCount-1 do
  if occurs[i] then StringGrid1.Cells[2,i]:=MakeCStyleString(texts[i]);
 changed:=true;
 Application.MessageBox('Importing successful','Success',MB_ICONINFORMATION);
end;

procedure TFoForm.ShowTextIDExecute(Sender: TObject);
var i,j:integer;
begin
 ShowTextID.Checked:=not ShowTextID.Checked;
 With StringGrid1 do
  if ShowTextID.Checked then
   begin
    Cells[0,0]:='Text ID';
    for i:=1 to StringGrid1.RowCount-1 do
     begin
      j:=Integer(Objects[0,i]);
      if j=-1 then
       Cells[0,i]:=''
      else
       Cells[0,i]:=IntToHex(j,4)+'h';
     end;
   end
  else
   begin
    Cells[0,0]:='Number';
    for i:=1 to StringGrid1.RowCount-1 do
     Cells[0,i]:=IntToStr(i);
   end;
end;

procedure TFoForm.RefreshStatusBar;
var s:string;
    i:integer;
begin
 {Show text ID/text number in status bar if any}
 if ShowTextID.Checked then
  s:='Text number: '+IntToStr(Row)
 else
  begin
   i:=Integer(StringGrid1.objects[0,Row]);
   s:='Text ID: ';
   if i=-1 then
    s:=s+'N/A'
   else
    s:=s+IntToHex(i,4)+'h';
  end;
 StatusBar1.SimpleText:=s;
end;

procedure TFoForm.ExportToGRFExecute(Sender: TObject);
begin
 PreviewTimer.Enabled:=false;
 ExportGrf.showModal;
 PreviewTimer.Enabled:=Preview.Checked;
end;

function TFoForm.TTDTextToWideString(const TTDText: string): WideString;
var pos:cardinal;
    b:byte;
    w:word;
    l:cardinal;
begin
 if (Length(TTDText)>=2) and (TTDText[1]=#$c3) and (TTDText[2]=#$9e) then
  {UTF-8 encoded}
  begin
   pos:=3;
   Result:='';
   l:=length(TTDText);
   while pos<=l do
    begin
     b:=ord(TTDText[pos]);
     if (b in [$c0..$df]) and (pos+1<=l) and (ord(TTDText[pos+1]) in [$80..$bf]) then
      begin
       w:=(b and $1f) shl 6 + (ord(TTDText[pos+1]) and $3f);
       pos:=pos+2;
      end
     else if (b in [$e0..$ef]) and (pos+2<=l) and (ord(TTDText[pos+1]) in [$80..$bf]) and
             (ord(TTDText[pos+2]) in [$80..$bf]) then
      begin
       w:=(b and $0f) shl 12 + (ord(TTDText[pos+1]) and $3f) shl 6 + (ord(TTDText[pos+2]) and $3f);
       pos:=pos+3;
      end
     else
      begin
       w:=b;
       if w in [$80..$9D, $A0, $AA, $AC, $AD, $AF, $B4..$B8] then
        w:=$e000+w
       else if w=$9E then
        w:=$20ac
       else if w=$9F then
        w:=$178;
       inc(pos);
      end;
     Result:=Result+WideChar(w);
    end;
  end
 else
  begin
   SetLength(Result,Length(TTDText));
   for pos:=1 to length(TTDText) do
    begin
     w:=ord(TTDText[pos]);
     if w in [$7B..$9D, $A0, $AA, $AC, $AD, $AF, $B4..$B8] then
      w:=$e000+w
     else if w=$9E then
      w:=$20ac
     else if w=$9F then
      w:=$178;
     Result[pos]:=WideChar(w);
    end;
  end;
end;

function TFoForm.WideStringToTTDText(const s: WideString;allowUtf8:boolean=true): string;
var NeedsUTF: boolean;
    i:cardinal;
    w:word;
begin
 NeedsUTF:=false;
 if allowUtf8 then
   for i:=1 to length(s) do
    if not ( (ord(s[i]) in [0..$7A,$80..$9D,$A1..$A9,$AB,$AE,$B0..$B3,$B9..$FF]) or
             (s[i]=#$20AC) or (s[i]=#$178) or ((ord(s[i]) and $FF00)=$E000) ) then
     begin
      NeedsUTF:=true;
      Break;
     end;
 if NeedsUTF then
  begin
    Result:=#$C3#$9E;
    for i:=1 to length(s) do
     begin
      w:=ord(s[i]);
      if w in [0..$7F,$A1..$A9,$AB,$AE,$B0..$B3,$B9..$BF] then
       Result:=Result+char(w)
      else if w=$20ac then
       Result:=Result+#$9E
      else if w=$0108 then
       Result:=Result+#$9F
      else if ((w and $FF00)=$E000) and ((w and $FF) in [$80..$A0,$AA,$AC..$AF,$B4..$B9]) then
       Result:=Result+char(w and $FF)
      else if w <= $7ff then
       Result:=Result+char($c0 or (w shr 6))+char($80 or (w and $3F))
      else
       Result:=Result+char($e0 or (w shr 12))+char($80 or ((w shr 6) and $3F)) +
               char($80 or (w and $3F));
     end;
  end
 else
  begin
   Result:='';
   for i:=1 to length(s) do
    case ord(s[i]) of
     $20ac:     Result:=Result+#$9E;
     $0108:     Result:=Result+#$9F;
     else       Result:=Result+char(ord(s[i]) and $FF);
    end;
  end;
end;


end.
